      $SET SQL(dbman=JDBC)
      $SET SOURCEFORMAT(VARIABLE)
      ****************************************************************
      * Copyright (C) Micro Focus 1988-2014. All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      * 
      ****************************************************************
       WORKING-STORAGE SECTION.

      *  Include the SQL Communications Area. This includes the
      *  definitions of SQLCODE, etc
       EXEC SQL INCLUDE SQLCA END-EXEC

           EXEC SQL BEGIN DECLARE SECTION END-EXEC
       01 WK-DSN             PIC X(2) VALUE "pg".
       01 INT-COL            PIC S9(04) COMP-5.
       01 VARCHAR-COL        PIC X(20).
       01 VARCHAR-COL-NULL   PIC S9(04)  COMP-5.
           EXEC SQL END DECLARE SECTION END-EXEC
       01 MFSQLMESSAGETEXT  PIC X(250).
      *
       PROCEDURE DIVISION.
       MAIN-PROC.

           EXEC SQL
             WHENEVER SQLERROR GO TO DB-Error
           END-EXEC.

           DISPLAY "Create/insert/update/select/drop test".
           DISPLAY " ".

      *    Connect to the specified database
           EXEC SQL
               CONNECT TO :WK-DSN WITH NO PROMPT
           END-EXEC.

           DISPLAY 'Create table'.
           EXEC SQL
               create table mfesqltest (
                   int_col  integer not null,
                   varchar_col varchar(20))
           END-EXEC.

           DISPLAY 'Insert first row'.
           MOVE 1 to INT-COL.
           MOVE "Single byte chars" TO VARCHAR-COL.
           EXEC SQL
               insert into mfesqltest
                   (int_col, varchar_col) values
                   (:INT-COL, :VARCHAR-COL)
           END-EXEC.

           DISPLAY 'Insert second row containing Japanese characters'.
           MOVE 2 to INT-COL.
           MOVE "" TO VARCHAR-COL.
           EXEC SQL
               insert into mfesqltest
                   (int_col, varchar_col) values
                   (:INT-COL, :VARCHAR-COL)
           END-EXEC.

           DISPLAY 'Commit the insertion'.
           EXEC SQL
               commit transaction
           END-EXEC.

           DISPLAY 'Update row'.
           MOVE 2 TO INT-COL.
           MOVE "" TO VARCHAR-COL.
           EXEC SQL
               update mfesqltest
                   set varchar_col = :VARCHAR-COL
                   where int_col = :INT-COL
           END-EXEC.

           DISPLAY 'Commit the change'.
           EXEC SQL
               commit transaction
           END-EXEC.

           DISPLAY 'Fetch '
           EXEC SQL
               declare vcurs cursor for
                   select int_col, varchar_col
                   from mfesqltest
           END-EXEC.

           EXEC SQL
               open vcurs
           END-EXEC.

           PERFORM UNTIL SQLSTATE >= "02000"
              EXEC SQL
                FETCH vcurs  INTO
                   :INT-COL
                  ,:VARCHAR-COL:VARCHAR-COL-NULL
              END-EXEC

              IF SQLSTATE < "02000"
                 DISPLAY "************************************"
                 DISPLAY "int_col     : " INT-COL
                 DISPLAY "varchar_col : " VARCHAR-COL
              END-IF
           END-PERFORM.
           DISPLAY "************************************".

           EXEC SQL
               close vcurs
           END-EXEC.

      *    Start a new transaction to avoid mixing DML and DDL
      *    as this will upset some data sources
           EXEC SQL commit END-EXEC.

           DISPLAY 'Drop table'
           EXEC SQL
               drop table mfesqltest
           END-EXEC.

           DISPLAY 'Disconnect'
           EXEC SQL
               commit work release
           END-EXEC.

           DISPLAY "Test completed without error"

           STOP RUN.

       DB-Error Section.

           DISPLAY "SQL Error = " SQLSTATE " " SQLCODE.
           DISPLAY MFSQLMESSAGETEXT.
           EXEC SQL
               commit work release
           END-EXEC.
           STOP RUN.
